---

 source/interpret.c |   13 ++++++++-----
 source/interpret.h |    1 +
 2 files changed, 9 insertions(+), 5 deletions(-)

diff --quilt old/source/interpret.c new/source/interpret.c
--- old/source/interpret.c
+++ new/source/interpret.c
@@ -292,17 +292,16 @@ AccumulatorData *BeginCreatingProgram(co
 Program *FinishCreatingProgram(AccumulatorData *old)
 {
     Program *newProg;
-    int progLen;
     
     newProg = XtNew(Program);
     newProg->name = LookupString(ProgramName, True);
-    progLen = ProgP - Prog;
-    newProg->code = (Inst *)XtCalloc(progLen, sizeof(Inst));
-    memcpy(newProg->code, Prog, progLen * sizeof(Inst));
+    newProg->progLen = ProgP - Prog;
+    newProg->code = (Inst *)XtCalloc(newProg->progLen, sizeof(Inst));
+    memcpy(newProg->code, Prog, newProg->progLen * sizeof(Inst));
     newProg->nested   = False;
     newProg->refcount = 0;
     
-    DISASM(newProg->name, newProg->code, ProgP - Prog);
+    DISASM(newProg->name, newProg->code, newProg->progLen);
     
     XtFree((char *)Accumulator);
     Accumulator = old;
@@ -1265,6 +1264,10 @@ static void addToGlobalSymTab(Symbol *sy
 
 #define JUMP(a) \
     do { \
+        Program *prog = FP_GET_PROG(FrameP); \
+        if (!(prog->code <= (a) && (a) < (prog->code + prog->progLen))) { \
+            EXEC_ERROR("Branch target outside current frame", NULL); \
+        } \
         PC = (a); \
     } while (0)
 
diff --quilt old/source/interpret.h new/source/interpret.h
--- old/source/interpret.h
+++ new/source/interpret.h
@@ -122,6 +122,7 @@ typedef struct SymbolRec {
 
 typedef struct ProgramTag {
     const char *name;
+    unsigned progLen;
     Inst *code;
     unsigned nested:1;
     unsigned refcount:31;
